const PMAP_PORT = 111;
struct mapping {
	int prog;
	int vers;
	int prot;
	int port;
};

const IPPROTO_TCP=6;
const IPPROTO_UDP=17;

struct pmap {
	mapping map;
	pmap *next;
};

typedef pmap *pmaplist;

struct call_args {
	int prog;
	int vers;
	int proc;
	opaque args<>;
};

struct call_res {
	int port;
	opaque res<>;
};

program PMAP_PROG {
	version PMAP_VERS {
		void       PMAPPROC_NULL(void)         = 0;
		bool       PMAPPROC_SET(mapping)       = 1;
		bool       PMAPPROC_UNSET(mapping)     = 2;
		int        PMAPPROC_GETPORT(mapping)   = 3;
		pmaplist   PMAPPROC_DUMP(void)         = 4;
		call_res   PMAPPROC_CALLIT(call_args)  = 5;
	} = 2;
} = 100000;
