#include <stdio.h>
#include <rpc/rpc.h>

#include <rpc/types.h>


typedef bool_t boolean;
bool_t xdr_boolean();

typedef int int32;
bool_t xdr_int32();

typedef double dbl;
bool_t xdr_dbl();

int main(argc, argv)
     int argc;
     char *argv[];
{
    XDR xdr;
    int i = 1300;
    int b = 1;
    double d = 42.13;

    xdrstdio_create(&xdr, stdout, XDR_ENCODE);
    xdr_int(&xdr, &i);
    xdr_bool(&xdr, &b);
    xdr_double(&xdr, &d);

    fflush(stdout);
    return 0;
}
